/*
 * Ptol fulltext area img cache, getting ready to reload bigger versions of the thumbnails after the ajax call is complete
 * is done for printing.
 * 
 */
  	function preloadImages(array) {
        	    if (!preloadImages.list) {
        	        preloadImages.list = [];
        	    }
	    
        	    for (var i = 0; i < array.length; i++) {
        	        var img = new Image();
        	        img.onload = function() {
        	            var index = preloadImages.list.indexOf(this);
        	        }
        	        preloadImages.list.push(img);
        	        img.src = array[i];
        	    }
	
  	}
  	
  	
var FTHTApp = FTHTApp || {
    shutOffInlineSearch: false,
    stdTimeout: 120000,
    /**
     * Set up section jump menu...
     */
    jumpMenuSetUp: function() {
        var $abstractHeading,
            $linkPoint,
            newHtml,
            whichSection = 2;
        whichSection = $("div.article-title-and-authors .sectionDivider").length;
        whichSection += $("div.article-abstract .sectionDivider").length;

        if ($(".introduction-section-link").length > 0) {
            $("a.introduction-section-link").remove();
        }

        $("a[href='#top']:eq(" + whichSection + ")").remove();
        $('div.sectionDivider:eq(' + whichSection + ')').attr("id","top");
        // Create a new link to abstract into all dropdown menus...
        $abstractHeading = $("#fulltextAbstract h3").eq(0);
        $linkPoint = $(".dropDownMenu ul");
        newHtml = '<li><a class="menuLink" href="#fulltextAbstract">' + $abstractHeading.text() + '</a></li>';
        // Insert new link...
        if ($linkPoint.length) {
            $linkPoint.prepend(newHtml);
        }
    },
    /**
    * Set up for Data & Media tab
    */
    dataAndMediaSetUp: function() {
        if ($("#dataAndMediaMatches").is(":empty")) {
            $("#dataAndMediaMatches").remove();
            $("#dataAndMediaTitle").remove();
            $(".dataAndMediaLink").remove();
        }
    },
    /**
     *  Use AHAH to fetch full text
     */
    fetchFulltextHtml: function() {
        var target = $(".itemFullTextHtml"),
            fulltextUrl = target.html(),
            docserverReq = "",
            noFullTextMsg = "The full text of this article is not currently available.";

        if (target.hasClass("retrieveFullTextHtml") ) {
            fulltextUrl = fulltextUrl.replace(/&amp;/g, "&");
            $("#itemFullTextId").empty();
            $.ajax({
                type: "GET",
                url: fulltextUrl,
                success: function(resp) {
                    docserverReq = resp;
                    var a = $('<a>', { href:docserverReq } )[0],
                        dsUrl = a.pathname + a.search;
                    if (!dsUrl.match(/^\//)) {
                        dsUrl = "/" + dsUrl;
                    }
                    $.ajax({
                        type: "GET",
                        url: dsUrl,
                        timeout: FTHTApp.stdTimeout,
                        success: function(ftresp) {
                            var target = $(".itemFullTextHtml"),
                                container = document.getElementById("itemFullTextId"),
                                ajaxNode = document.createElement("span"),
                                mathscript,
                                config,
                                itemWebId;
                            target.removeClass("retrieveFullTextHtml hiddenjsdiv");
                            target.html();

                            ajaxNode.innerHTML = ftresp;
                            container.insertBefore(ajaxNode, container.firstChild);

                            FTHTApp.jumpMenuSetUp();
                            FTHTApp.dataAndMediaSetUp();

                            mathscript = document.createElement("script");
                            mathscript.type = "text/javascript";
                            mathscript.src = "//cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML";

                            config = "MathJax.Hub.Startup.onload();";

                            if (window.opera) {
                                mathscript.innerHTML = config;
                            } else {
                                mathscript.text = config;
                            }

                            container.insertBefore(mathscript, container.firstChild);
                            MathJax.Hub.Queue(["Typeset",MathJax.Hub]);

                            itemWebId = $("#itemWebIdForRefs").text();

                            // If there are no references then this will not be loaded, so check before calling...
                            if (typeof REFApp !== "undefined" && typeof REFApp.fetchReferenceMatches === "function") {
                               REFApp.fetchReferenceMatches(itemWebId, "fulltext");
                            }
                        },
                        error: function(ftreq, statusText){
                            $("#itemFullTextId").innerHTML = $("#no_fulltext_label").text() || noFullTextMsg;
                            var cMsg = "'fulltext' AJAX GET (Stage 2) to '" + resp + "' failed: " + ftreq.status + " (" + statusText + ")";
                        },
                        complete: function(ftresp, statusText) {
                            $(".itemFullTextLoading").remove();     // Remove the spinning icon...
                           /* If fulltext has loaded on PTOL magazine article page */   
                           if ($("#magazinearticle .itemFullTextHtml span").length > 0){   
                        	   var imgArray = [];

	                          	/* Looping through all thumbnails to get image path then take off '_thmb' so 
	                          	 * we now have a larger version stored for each in an Array */
	                        	$.each($(".image a img"),function(){
	                        		var $thisSrc, $thisNewSrc ,$this = $(this);
	                        		$thisSrc = $this.attr("src");
	                        		$thisNewSrc = $thisSrc.replace("_thmb","");
	                        		imgArray.push($thisNewSrc);
	                        	});
	                        	/* Call function to cache larger versions of the images in fulltext ajax call */
	                        	preloadImages(imgArray);
                        	                             
                           }
                              
                              
                              
                              
                              
                              
                        }
                    });
                },
                error: function(req, statusText){
                    $("#itemFullTextId").innerHTML = $("#no_fulltext_label").text() || noFullTextMsg;
                    var cMsg = "'fulltext' AJAX GET (Stage 1) to '" + fulltextUrl + "' failed: " + req.status + " (" + statusText + ")";
                },
                complete: function(ftresp, statusText) {
                    $(".itemFullTextLoading").remove();     // Remove the spinning icon...
                }
            });
        }
    },
    /**
    *
    * @param e
    * @returns {Boolean}
    */
    runInLineSearch: function(e) {

        var singlePreview = $("#singlePreview"),
            searchServiceUrl = "",
            selection = FTHTApp.getSelectioner(),
            strLength = selection.length;
        singlePreview.find(".inlineSearch").remove();
        singlePreview.hide();

        if (selection !== "" && strLength > 2 && strLength < 100) {
            var publicationTitle = $(".searchtitle").html(),
                hiddenContext = $("#hiddenContext").text(),
                resultCategory = "ResearchPublicationContent",
                publicationIdent = $("#volumepage-search-form #searchpublication").attr("value"),
                currentItemId = $(".metadata_itemWebId").first().text();
            singlePreview.dialog("open");
            singlePreview.show();
            singlePreview.append("<img src=\"/images/jp/spinner.gif\" alt=\"Loading related articles...\" />");
            if (publicationTitle === "Physics Today" ) {
                resultCategory = "MagazineContent";
            }
            searchServiceUrl = encodeURI(hiddenContext +
                               "/search/ahahsearch?value1='" + selection +
                               "'&option1=fulltext&value8=" + publicationIdent +
                               "&operator8=AND&option8=pub_serialIdent&option912=resultCategory&value912=" + resultCategory +
                               "&operator912=AND&operator13=NOT&option13=webId&value13=" + currentItemId +
                               "&fmt=ahah&noRedirect=true&pageSize=5&publicationTitle=" + publicationTitle.replace("&","%26"));

           // AJAX call converted from simple $.get to full $.ajax to allow more graceful handling of errors...
           $.ajax({
               type: "GET",
               data: "",
               dataType: "text",
               url: searchServiceUrl,
               success: function(resp, statusText) {
                   if (resp !== null) {
                       var innerSearch = "<div class='inlineSearch'>" + resp + "</div>";
                       singlePreview.find(".inlineSearch").remove();
                       singlePreview.get(0).innerHTML = innerSearch;
                       MathJax.Hub.Queue(["Typeset", MathJax.Hub, singlePreview.get(0)], [function() {
                           // Display the dialog after mathjax has done it's work
                           singlePreview.dialog({width:"500",position:[e.pageX, e.pageY + 20], modal: false, autoOpen: false});
                           singlePreview.dialog().parent(".ui-dialog").wrap("<div class='singlePreviewWrapper'></div>");
                           singlePreview.dialog("open");
                           singlePreview.css("display","block");
                           singlePreview.find("img").remove();
                       }]);
                   }
               },
               error: function(req, statusText) {
                   singlePreview.find("img").remove();
               }
           });
           return false;
        }
    },
    getSelectioner: function() {
        var userSelection;
        if (window.getSelection) {
            userSelection = (window.getSelection()).toString();
        }
        else if (document.selection) { // should come last; Opera!
            userSelection = (document.selection.createRange()).text;
        }
        return userSelection;
    }
};

$(document).ready(function() {

    var hiddenContext = $("#hiddenContext").text(),
        siqUrl = hiddenContext + "/siq/siq.action";

    //In line search
    if (FTHTApp.shutOffInlineSearch !== true ) {
        $(".articlefulltext").live("mouseup", function (e){
            FTHTApp.runInLineSearch(e);
        });
    }

    // Two actions to support FullText in article and chapter...
    $(".menuButton").live("click", function (e) {
        var $this = $(this),
            parentContainer = $this.closest(".articleSection"),
            currentMenu = parentContainer.find(".dropDownMenu");
        e.preventDefault();
        currentMenu.slideToggle(250);
        $this.toggleClass("up");
    });

    $(".menuLink, .menubutton.gototoplinkFT").live("click", function () {
        $(".dropDownMenu").hide(100);
        return true;
    });

    // As needed, retrieve the full text of an article, a chapter or contributors...
    $("#articlefulltext a").click(function(e) {
        var webId = $(".siqItemId").text(),
        pageTitle = $(".siqPageTitle").text(),
        doi = $(".siqDoi").text(),
        isActive = $(".siqFullTextHTMLTabEnabled").text(),
        logPub2webEvent = false;
        e.preventDefault();
        FTHTApp.fetchFulltextHtml();
        if (!$(".itemFullTextHtml").hasClass("retrieveFullTextHtml")) {
            logPub2webEvent = true;
        }
        if (isActive) {
            AIPApp.siq(siqUrl, webId, pageTitle, doi, "FulltextHTMLDownload", logPub2webEvent);
        }
    });

    if ($("#articlefulltext.active").length > 0) {
        var $abstractSection = $(".tabbedsection.abstract"),
            $fulltextSection = $(".tabbedsection.articlefulltext"),
            $insertionPoint = $(".tabbedsection.articlefulltext .abstract-container"),
            $abstractHeading = $fulltextSection.find(".articleabstract h3"),
            $keywordsClone;

        $abstractHeading.show().addClass("sectionDivider title");
        $keywordsClone = $abstractSection.find(".keywords-container").clone();
        $insertionPoint.after($keywordsClone);
        $fulltextSection.show();
        $fulltextSection.find(".keywords-container").show();
        // Trigger the display of the text...
        $("#articlefulltext a").trigger("click");
    }

});

/**
 * Function used by legacy XSLT
 *
 * @param filename
 */
function popupImage(filename) {
    // Use the same proportions as the dialog box
    var w_width  = $(window).width()  * 0.8,
        w_height = $(window).height() * 0.8,
        w_params = "menubar=no,width=" + w_width + ",height=" + w_height + ",toolbar=no,resizeable=yes,scrollbars=yes";
    window.open(filename, "figWindow", w_params);
}
